%define root	crack

%define major		2
%define libname		%mklibname %{root} %{major}
%define develname	%mklibname %root -d

Summary:	A password-checking library
Name:		cracklib
Version:	2.9.6
Release:	%mkrel 5
Group:		System/Libraries
License:	LGPLv2
URL:		http://sourceforge.net/projects/cracklib/
Source0:	https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-%{version}.tar.gz
Source1:        https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-words-%{version}.gz

# No upstream source for this, just words missing from the current cracklib-words
Source10:	missing-words.gz

Patch0:		cracklib-2.8.22-fix-python-path.patch
Patch1:		cracklib-2.9.1-inttypes.patch
Patch2:		cracklib-2.9.6-cve-2016-6318.patch
Patch3:		cracklib-2.9.5-overflow-processing-long-words.patch
Conflicts:	libcrack2 < 2.8.15
Conflicts:	lib64crack2 < 2.8.15
BuildRequires:	gettext-devel
BuildRequires:	zlib-devel

%description
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics. You can use CrackLib to stop
users from choosing passwords which would be easy to guess. CrackLib
performs certain tests: 

* It tries to generate words from a username and gecos entry and 
  checks those words against the password;
* It checks for simplistic patterns in passwords;
* It checks for the password in a dictionary.

CrackLib is actually a library containing a particular
C function which is used to check the password, as well as
other C functions. CrackLib is not a replacement for a passwd
program; it must be used in conjunction with an existing passwd
program.

Install the cracklib package if you need a program to check users'
passwords to see if they are at least minimally secure. If you
install CrackLib, you'll also want to install the cracklib-dicts
package.

%package -n	%{libname}
Summary:	A password-checking library
Group:		System/Libraries
Obsoletes:	cracklib < %{version}-%{release}

%description -n %{libname}
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%package -n	%{libname}-python
Summary:	A password-checking library
Group:		System/Libraries
Obsoletes:	cracklib-python < %{version}-%{release}
BuildRequires:	python
BuildRequires:	python-devel

%description -n %{libname}-python
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%package	dicts
Summary:	The standard CrackLib dictionaries
Group:		System/Libraries

%description	dicts
The cracklib-dicts package includes the CrackLib dictionaries.
CrackLib will need to use the dictionary appropriate to your system,
which is normally put in /usr/share/dict/words.  Cracklib-dicts also contains
the utilities necessary for the creation of new dictionaries.

If you are installing CrackLib, you should also install cracklib-dicts.

%package -n	%{develname}
Summary:	Cracklib link library & header file
Group:		Development/C
Provides:	lib%{root}-devel = %{version}-%{release}
Provides:	%{root}lib-devel = %{version}-%{release}
Requires:	%{libname} = %{version}
Obsoletes:	cracklib-devel < %{version}-%{release}
Obsoletes:	%{mklibname crack 2 -d} < %{version}-%{release}

%description -n	%{develname}
The cracklib devel package include the needed library link and
header files for development.

%prep
%setup -q
%patch0 -p0
cp -p lib/packer.h lib/packer.h.in
%patch1 -p1 -b .inttypes
%patch2 -p1 -b .CVE-2016-6318
%patch3 -p1 -b .overflow

for dict in %{SOURCE10} %{SOURCE1}
do
    cp ${dict} dicts/
done

%build
autoreconf -vfi
%configure2_5x --libdir=/%{_lib}
%make

%install
%makeinstall_std

chmod 0755 ./util/cracklib-format ./util/cracklib-packer
./util/cracklib-format dicts/* | ./util/cracklib-packer %{buildroot}%{_datadir}/cracklib/pw_dict

ln -s cracklib-format %{buildroot}%{_sbindir}/mkdict
ln -s cracklib-packer %{buildroot}%{_sbindir}/packer

ln -s %{_datadir}/cracklib/pw_dict.hwm %{buildroot}%{_libdir}/cracklib_dict.hwm
ln -s %{_datadir}/cracklib/pw_dict.pwd %{buildroot}%{_libdir}/cracklib_dict.pwd
ln -s %{_datadir}/cracklib/pw_dict.pwi %{buildroot}%{_libdir}/cracklib_dict.pwi

install -m644 lib/packer.h %{buildroot}%{_includedir}/

%find_lang %{name}

%files -n %{libname}
/%{_lib}/*.so.%{major}*


%files -n %{libname}-python
%{py_platsitedir}/cracklib*
%{py_platsitedir}/_cracklib*
%{py_platsitedir}/test_cracklib*

%files -f %{name}.lang
%doc AUTHORS NEWS README*

%files -n %{develname}
%{_includedir}/*
/%{_lib}/*.so
/%{_lib}/*.*a

%files dicts
%{_sbindir}/*
%{_datadir}/%{name}
%{_libdir}/cracklib_dict.*


%changelog
* Mon Dec 12 2016 luigiwalser <luigiwalser> 2.9.6-5.mga6
+ Revision: 1074402
- rediff updated CVE-2016-6318 patch from fedora

* Tue Aug 23 2016 luigiwalser <luigiwalser> 2.9.6-4.mga6
+ Revision: 1048069
- add patch from opensuse to fix buffer overflow processing long words (bsc#992966)

* Tue Aug 16 2016 luigiwalser <luigiwalser> 2.9.6-3.mga6
+ Revision: 1046514
- add patch from redhat to fix CVE-2016-6318

* Thu Jan 07 2016 luigiwalser <luigiwalser> 2.9.6-2.mga6
+ Revision: 920363
- do not enable libtoolize

* Thu Jan 07 2016 luigiwalser <luigiwalser> 2.9.6-1.mga6
+ Revision: 920358
- 2.9.6
- update source URLs
- use current upstream sources
- add missing words from fedora (source10)

* Fri Aug 21 2015 tmb <tmb> 2.9.2-3.mga6
+ Revision: 867437
- rebuild for new gcc

* Wed Oct 15 2014 umeabot <umeabot> 2.9.2-2.mga5
+ Revision: 747793
- Second Mageia 5 Mass Rebuild

* Tue Oct 14 2014 luigiwalser <luigiwalser> 2.9.2-1.mga5
+ Revision: 738703
- 2.9.2

* Sat Sep 27 2014 tv <tv> 2.9.1-5.mga5
+ Revision: 726065
- rebuild for missing pythoneggs deps

* Thu Sep 18 2014 umeabot <umeabot> 2.9.1-4.mga5
+ Revision: 693696
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 2.9.1-3.mga5
+ Revision: 678581
- Mageia 5 Mass Rebuild

* Sat May 31 2014 pterjan <pterjan> 2.9.1-2.mga5
+ Revision: 628144
- Rebuild for new Python

* Wed Dec 11 2013 luigiwalser <luigiwalser> 2.9.1-1.mga4
+ Revision: 556390
- 2.9.1
- update patch1 (from fedora)

* Sat Oct 19 2013 umeabot <umeabot> 2.9.0-2.mga4
+ Revision: 528968
- Mageia 4 Mass Rebuild

* Sun Jun 30 2013 luigiwalser <luigiwalser> 2.9.0-1.mga4
+ Revision: 448442
- 2.9.0

* Fri Jan 11 2013 umeabot <umeabot> 2.8.22-3.mga3
+ Revision: 348293
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Dec 31 2012 wally <wally> 2.8.22-2.mga3
+ Revision: 336599
- fix build with new automake 1.13
- clean .spec a bit

* Tue Dec 25 2012 luigiwalser <luigiwalser> 2.8.22-1.mga3
+ Revision: 334782
- rediff patch0
- 2.8.22

* Sun Aug 05 2012 luigiwalser <luigiwalser> 2.8.19-1.mga3
+ Revision: 278897
- 2.8.19

* Thu Sep 08 2011 tv <tv> 2.8.18-1.mga2
+ Revision: 141523
- new release
- BR gettext-devel
- rediff P0
- patch 1, 2: add fixes from fedora

* Tue Jan 18 2011 pterjan <pterjan> 2.8.16-4.mga1
+ Revision: 21833
- Rebuild for python 2.7

* Sun Jan 09 2011 blino <blino> 2.8.16-3.mga1
+ Revision: 1623
- remove old ldconfig scriptlets
- imported package cracklib

